package android.usp.ime.tcc.geocommunication;

import java.io.Serializable;

import usp.ime.gclib.Device;
import usp.ime.gclib.hit.TargetRestrictions;
import usp.ime.gclib.sensor.location.LocationGpsListener;
import usp.ime.gclib.sensor.orientation.OrientationSensorListener;

public class Parameters implements Serializable {
	
	private static final long serialVersionUID = 1L;

	public static String PARAMETER_NAME = "parameters";
	
	private Device device;
	private LocationGpsListener listenerLocation;
	private OrientationSensorListener listenerOrientation;
	private TargetRestrictions targetRestrictions;
	
	private static Parameters parameters;
	
	public static Parameters getInstance(Device device) {
		if(parameters == null)
			parameters = new Parameters(device);
		return parameters;
	}
	
	private Parameters(Device device) {
		this.device = device;
		this.listenerLocation = new LocationGpsListener(device);
		this.listenerOrientation = new OrientationSensorListener(device);
		this.targetRestrictions = new TargetRestrictions();
	}

	public Device getDevice() {
		return device;
	}
	
	public LocationGpsListener getListenerLocation() {
		return listenerLocation;
	}
	
	public OrientationSensorListener getListenerOrientation() {
		return listenerOrientation;
	}

	public TargetRestrictions getTargetRestrictions() {
		return targetRestrictions;
	}

	public void setTargetRestrictions(TargetRestrictions targetRestrictions) {
		this.targetRestrictions = targetRestrictions;
	}
	
}
