package android.usp.ime.tcc.geocommunication;

import java.util.ArrayList;
import java.util.List;

public class PlayersList {
	
	private List<PlayersInformation> playerList;
	
	public PlayersList() {
		playerList = new ArrayList<PlayersInformation>();
	}
	
	public void add(String nick, String ip) {
		playerList.add(new PlayersInformation(ip, nick));
	}
	
	public void remove(String ip) {
		for (PlayersInformation player : playerList) {
			if(player.getIp().equals(ip)) {
				playerList.remove(player);
				break;
			}
		}
	}
	
	public int getListSize() {
		return playerList.size();
	}
	
	public List<PlayersInformation> getPlayerList() {
		return playerList;
	}
	
	public boolean isAlreadyAdd(String ip) {
		for (PlayersInformation player : playerList) {
			if(player.getIp().equals(ip))
				return true;
		}
		return false;
	}
	
	public List<String> getIPList(String myIP) {
		List<String> ipList = new ArrayList<String>();
		for (PlayersInformation player : playerList) {
			if(player != null && !player.getIp().equals(myIP))
				ipList.add(player.getIp());
		}
		return ipList;
	}
	
	public static PlayersList getObjectFromString(String playerList) {
		PlayersList list = new PlayersList();
		String[] players = playerList.split(";");
		
		for(int i = 0; i < players.length; i++){
			String player[] = players[i].split(":");
			if(player.length != 2)
				return null;
			list.add(player[1], player[0]);
		}
		
		return list;
	}
	
	@Override
	public String toString() {
		String s = "";
		
		int listSize = playerList.size();
		
		for (PlayersInformation player : playerList) {
			s += player.getIp() + ":" + player.getNick();
			if(listSize > 1)
				s += ";";
			listSize--;
		}
		
		return s;
	}
}
