package android.usp.ime.tcc.geocommunication;

import java.io.Serializable;
import java.util.Arrays;
import java.util.Random;

import android.usp.ime.tcc.newbatataquente.R;

public class Potato implements Serializable {

	private static final long serialVersionUID = 1L;
	private static final int NUMBER_POTATO_STATES = 4;
	
	private int totalTime;
	private int atualTime;
	private int[] parcialTimes = new int[NUMBER_POTATO_STATES];
	
	public int getTotalTime() {
		return totalTime;
	}
	
	public void setTotalTime(int totalTime) {
		this.totalTime = totalTime;
	}
	
	public int getAtualTime() {
		return atualTime;
	}

	public void setAtualTime(int atualTime) {
		this.atualTime = atualTime;
	}

	public EPotatoState getPotatoState() {
		if(atualTime <= parcialTimes[0])
			return EPotatoState.FRIA;
		if(atualTime <= parcialTimes[1])
			return EPotatoState.MORNA;
		if(atualTime <= parcialTimes[2])
			return EPotatoState.QUENTE;
		if(atualTime <= parcialTimes[3])
			return EPotatoState.QUEIMADA;
		
		//TODO Apagar isso para verso final
		atualTime = 0;
		return EPotatoState.QUEIMADA;
	}
	
	public int[] getParcialTimes() {
		return parcialTimes;
	}
	
	public void setParcialTimes(int time1, int time2, int time3, int time4) {
		this.parcialTimes[0] = time1;
		this.parcialTimes[1] = time2;
		this.parcialTimes[2] = time3;
		this.parcialTimes[3] = time4; //TODO
	}
	
	public int getImageResource() {
		switch (getPotatoState()){
			case FRIA:
				return R.drawable.batata_fria_grande;
			case MORNA:
				return R.drawable.batata_morna_grande;
			case QUENTE:
				return R.drawable.batata_quente_grande;
			case QUEIMADA:
				return R.drawable.batata_queimada_grande;
			default:
				return R.drawable.batata_fria_grande;
		}
	}

	public void setRandomParcialTimes(int minTime, int maxTime) {
		Random rand = new Random();
		
		int gameTime = minTime + rand.nextInt(maxTime-minTime);
		
		int[] aux = new int[NUMBER_POTATO_STATES+1];
		aux[0] = 0;
		aux[NUMBER_POTATO_STATES] = gameTime;
		for(int i = 1; i < NUMBER_POTATO_STATES; i++)
			aux[i] = rand.nextInt(gameTime-1) + 1;
		
		Arrays.sort(aux);
		
		int times[] = new int[NUMBER_POTATO_STATES];
		for(int i = 0; i < NUMBER_POTATO_STATES; i++) {
			times[i] = aux[i+1] - aux[i];
 		}
		
		Arrays.sort(times);
		for(int i = NUMBER_POTATO_STATES-2; i >= 0; i--)
			times[i] += times[i+1];
		
		setParcialTimes(times[3], times[2], times[1], times[0]);
	}

}
