package android.usp.ime.tcc.newbatataquente;

import java.util.ArrayList;
import java.util.List;
import java.util.Timer;
import java.util.TimerTask;
import java.util.concurrent.FutureTask;
import java.util.concurrent.TimeUnit;

import usp.ime.gclib.net.communication.CommunicationSocket;
import usp.ime.gclib.net.communication.IReceiveListener;
import usp.ime.gclib.net.protocol.AppProtocol;
import usp.ime.gclib.net.protocol.EProtocolMessages;
import usp.ime.gclib.net.protocol.EProtocolTranspLayer;
import usp.ime.gclib.net.protocol.ESendTo;
import usp.ime.gclib.net.protocol.ProtocolGEOMSGInformation;
import usp.ime.gclib.net.protocol.ProtocolInformation;
import usp.ime.gclib.net.protocol.ProtocolLIBCONFIGInformation;
import android.app.Activity;
import android.app.AlertDialog;
import android.app.ProgressDialog;
import android.content.DialogInterface;
import android.content.DialogInterface.OnClickListener;
import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.usp.ime.tcc.geocommunication.EPotatoState;
import android.usp.ime.tcc.geocommunication.Parameters;
import android.usp.ime.tcc.geocommunication.PlayersInformation;
import android.usp.ime.tcc.geocommunication.PlayersList;
import android.usp.ime.tcc.geocommunication.Potato;
import android.usp.ime.tcc.geocommunication.StatusCode;
import android.usp.ime.tcc.soundVibrator.PlaySound;
import android.usp.ime.tcc.soundVibrator.Vibration;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;

public class BatataQuenteActivity extends Activity implements IReceiveListener {

	private PlaySound soundPool;
	private Vibration vibrator;

	private ImageView imageLargePotato;
	private TextView tvNickList;
	private TextView tvPlayerName;
	private TextView tvTouchPotato;
	private TextView tvPlayerHasPotato;

	private String strNickList;

	private boolean potatoWithMe;
	private boolean gameAlredyStart = false;
	private boolean sendingPotato;
	private boolean potatoSended;
	private boolean sendingPotatoError = false;
	private boolean updatePotatoView;

	private CommunicationSocket socket;

	private PlayersInformation playerHasPotato;
	private PlayersList playerList;
	private Parameters parameters;
	private Potato potatoObject;
	
	private ProgressDialog progressWaitGameStart;
	private Timer timerUpdateTimePotato;
	private Timer timerUpdateViews;
	
	
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_batata_quente);

		soundPool = new PlaySound(this);
		vibrator = new Vibration(this);
		soundPool.initSound(R.raw.tique);
		
		parameters = Parameters.getInstance(null);

		imageLargePotato = (ImageView) findViewById(R.id.largePotato);
		tvNickList = (TextView) findViewById(R.id.whoHasPotato);
		tvPlayerName = (TextView) findViewById(R.id.playerName);
		tvTouchPotato = (TextView) findViewById(R.id.tvTouchPotato);
		tvPlayerHasPotato = (TextView) findViewById(R.id.potato);

		tvPlayerName.setText(parameters.getDevice().getNick());

		/***************************************************************************/

		parameters.getDevice().startIp();

		playerHasPotato = new PlayersInformation("", "");
		playerList = new PlayersList();
		socket = new CommunicationSocket();
		socket.acceptListener(this, parameters.getDevice(), parameters.getTargetRestrictions());
		if(!parameters.getDevice().isAccessPoint()){
			AppProtocol app = new AppProtocol(EProtocolMessages.ONLINE, ESendTo.GATEWAY, EProtocolTranspLayer.TCP);
			ProtocolInformation protInfo = new ProtocolInformation(parameters.getDevice(), StatusCode.CODE_1.getBytes(), app);
			socket.sendMessage(app, protInfo);
			potatoWithMe = false;
		}
		else {
			potatoObject = new Potato();
			potatoObject.setAtualTime(0);
			potatoObject.setRandomParcialTimes(20, 50);
			playerList.add(parameters.getDevice().getNick(), parameters.getDevice().getIp());
			potatoWithMe = true;
			playerHasPotato.setIp(parameters.getDevice().getIp());
			playerHasPotato.setNick(parameters.getDevice().getNick());
		}

		/***************************************************************************/

		updatePotatoView();
		showAlert(parameters.getDevice().isAccessPoint());
		
		timerTaskUpdateViews();
		timerTaskUpdateTimePotato();

		prepareSendPotato();
	}

	private void updatePotatoView() {
		if(potatoWithMe) {
			tvTouchPotato.setVisibility(View.VISIBLE);
			imageLargePotato.setImageResource(potatoObject.getImageResource());
			tvPlayerHasPotato.setText("Voc");
		}
		else {
			tvTouchPotato.setVisibility(View.INVISIBLE);
			imageLargePotato.setImageResource(R.drawable.batata_transparente);
			tvPlayerHasPotato.setText(playerHasPotato.getNick());
		}
	}



	private void updateIpListView() {
		strNickList = "";
		boolean isFirst = true;
		for (PlayersInformation player : playerList.getPlayerList()) {
			if(!player.getIp().equals(parameters.getDevice().getIp())) {
				if(isFirst) {
					strNickList += player.getNick();
					isFirst = false;
				}
				else
					strNickList += ", " + player.getNick();
			}
		}
	}

	public void onReceiveGEOMSG(ProtocolGEOMSGInformation appInfo) {
		String codeStatus = new String(appInfo.getMessage());
		if(codeStatus.startsWith(StatusCode.CODE_4) && !appInfo.getDeviceSrc().getIp().equals(parameters.getDevice().getIp())) {
			System.out.println("RECEBI GEOMSG");
			List<String> list = new ArrayList<String>();
			list.add(appInfo.getDeviceSrc().getIp());
			AppProtocol app = new AppProtocol(EProtocolMessages.GEOACK, list, EProtocolTranspLayer.TCP);
			ProtocolInformation info = new ProtocolInformation(parameters.getDevice(), StatusCode.CODE_5.getBytes(), app);
			socket.sendMessage(app, info);
		}
	}

	public void onReceiveGEOACK(ProtocolInformation appInfo) {
		String codeStatus = new String(appInfo.getMessage());
		if(codeStatus.startsWith(StatusCode.CODE_5)) {
			if(sendingPotato && potatoWithMe && !potatoSended) {
				potatoSended = true;
				List<String> list = new ArrayList<String>();
				list.add(appInfo.getDeviceSrc().getIp());
				AppProtocol app = new AppProtocol(EProtocolMessages.APPDATA, list, EProtocolTranspLayer.TCP);
				ProtocolInformation info = new ProtocolInformation(parameters.getDevice(), potatoObject, app);
				socket.sendMessage(app, info);
			}
		}
	}

	public void onReceiveAPPDATA(ProtocolInformation appInfo) {
		
		if(appInfo.getObject() != null) {
			potatoObject = (Potato) appInfo.getObject();
			if(potatoObject == null) {
				System.out.println("ERRO NA RECEPO DA BATATA. - POTATO SIZE=" + appInfo.getMessage().length);
				List<String> list = new ArrayList<String>();
				list.add(appInfo.getDeviceSrc().getIp());
				AppProtocol app = new AppProtocol(EProtocolMessages.APPDATA, list, EProtocolTranspLayer.TCP);
				ProtocolInformation info = new ProtocolInformation(parameters.getDevice(), StatusCode.CODE_6.getBytes(), app);
				socket.sendMessage(app, info);
			}
			else {
				AppProtocol app = new AppProtocol(EProtocolMessages.APPDATA, playerList.getIPList(parameters.getDevice().getIp()), EProtocolTranspLayer.TCP);
				ProtocolInformation info = new ProtocolInformation(parameters.getDevice(), StatusCode.CODE_7.getBytes(), app);
				socket.sendMessage(app, info);
				playerHasPotato.setIp(parameters.getDevice().getIp());
				playerHasPotato.setNick(parameters.getDevice().getNick());
				potatoWithMe = true;
				updatePotatoView = true;
			}
		}
		else {
			String codeStatus = new String(appInfo.getMessage());
			if(codeStatus.startsWith(StatusCode.CODE_6)) {
				//ERRO NO ENVIO DA BATATA. A BATATA CONTINUA COMIGO.
				sendingPotato = false;
				sendingPotatoError = true;
			}
			else if(codeStatus.startsWith(StatusCode.CODE_7)) {
				//A BATATA FOI ENVIADA COM SUCESSO.
				vibrator.vibra(Vibration.SHORT_VIBRATION);
				potatoWithMe = false;
				sendingPotato = false;
				updatePotatoView = true;
				playerHasPotato.setIp(appInfo.getDeviceSrc().getIp());
				playerHasPotato.setNick(appInfo.getDeviceSrc().getNick());
			}
			else if(codeStatus.startsWith(StatusCode.CODE_8)) {
				//O jogador que enviou essa mensagem saiu do jogo.
				playerList.remove(appInfo.getDeviceSrc().getIp());
				updateIpListView();
			}
			else if(codeStatus.startsWith(StatusCode.CODE_9)) {
				vibrator.vibra(Vibration.SHORT_VIBRATION);
				AlertDialog.Builder builder = new AlertDialog.Builder(BatataQuenteActivity.this);
				builder.setTitle("");
				builder.setMessage("O " + appInfo.getDeviceSrc().getNick() + " perdeu.");
				builder.setCancelable(false);
				builder.setPositiveButton("Sair", new OnClickListener() {
					
					public void onClick(DialogInterface arg0, int arg1) {
						finish();
					}
				});
				builder.create().show();
				timerUpdateTimePotato.cancel();
			}
		}
	}

	public void onReceiveONLINE(ProtocolInformation appInfo) {
		if(parameters.getDevice().isAccessPoint()){
			List<String> list = new ArrayList<String>();
			list.add(appInfo.getDeviceSrc().getIp());
			AppProtocol app = new AppProtocol(EProtocolMessages.ONLINEANSWER, list, EProtocolTranspLayer.TCP);
			ProtocolInformation protInfo;
			if(gameAlredyStart){				
				 protInfo = new ProtocolInformation(parameters.getDevice(), StatusCode.CODE_2.getBytes(), app);
			}
			else {
				if(!playerList.isAlreadyAdd(appInfo.getDeviceSrc().getIp()))
					playerList.add(appInfo.getDeviceSrc().getNick(), appInfo.getDeviceSrc().getIp());
				updateIpListView();
				protInfo = new ProtocolInformation(parameters.getDevice(), StatusCode.CODE_3.getBytes(), app);
			}
			socket.sendMessage(app, protInfo);
		}

	}

	public void onReceiveLIBCONFIG(ProtocolLIBCONFIGInformation appInfo) {
		if(progressWaitGameStart != null && progressWaitGameStart.isShowing())
			progressWaitGameStart.cancel();
		gameAlredyStart = true;
		playerHasPotato.setIp(appInfo.getDeviceSrc().getIp());
		playerHasPotato.setNick(appInfo.getDeviceSrc().getNick());
		String players = new String(appInfo.getMessage());
		playerList = PlayersList.getObjectFromString(players);
		updateIpListView();
		updatePotatoView = true;
	}

	public void onReceiveONLINEANSWER(ProtocolInformation appInfo) {
		String serverResp = new String(appInfo.getMessage());
		if(serverResp.startsWith(StatusCode.CODE_3)) {
			//Esperar jogo comear 
		}
		else if(serverResp.startsWith(StatusCode.CODE_2)){
			finish();
		}
	}














	/***********************************Auxiliares************************/

	@Override
	public void onDestroy() {
		super.onDestroy();
		socket.stopListener();
	}
	
	@Override
	public void onBackPressed() {		
		AlertDialog.Builder builder = new AlertDialog.Builder(this);
		final AlertDialog alert;

		LayoutInflater inflater = getLayoutInflater();
		View layout = inflater.inflate(R.layout.dialog_exit, (ViewGroup) findViewById(R.id.allViewDialog));
		builder.setView(layout);
		builder.create();
		alert = builder.show();

		TextView tvMsg = (TextView) layout.findViewById(R.id.tvExitMsg);
		tvMsg.setText(getResources().getString(R.string.dialogMsgExitGame));

		Button exit = (Button) layout.findViewById(R.id.buttonExit);
		Button stay = (Button) layout.findViewById(R.id.buttonStay);
		exit.setOnClickListener(new View.OnClickListener() {

			public void onClick(View v) {
				if(soundPool.isLoaded())
					soundPool.play();
				alert.dismiss();
				alert.cancel();
				iAmLeaving();

				BatataQuenteActivity.super.onBackPressed();
			}
		});
		stay.setOnClickListener(new View.OnClickListener() {

			public void onClick(View v) {
				if(soundPool.isLoaded())
					soundPool.play();
				alert.dismiss();
				alert.cancel();
			}
		});
	}

	private void showAlert(boolean iAmAccessPoint) {
		if(iAmAccessPoint){
			AlertDialog.Builder builder = new AlertDialog.Builder(BatataQuenteActivity.this);
			AlertDialog alert;
			builder.setTitle("");
			builder.setMessage("Esperando o jogo comear");
			builder.setNegativeButton("Sair", new OnClickListener() {

				public void onClick(DialogInterface dialog, int which) {
					finish();
				}
			});
			builder.setPositiveButton("Comear", new OnClickListener() {

				public void onClick(DialogInterface dialog, int which) {
					gameAlredyStart = true;
					AppProtocol app = new AppProtocol(EProtocolMessages.LIBCONFIG, playerList.getIPList(parameters.getDevice().getIp()), EProtocolTranspLayer.TCP);
					ProtocolLIBCONFIGInformation protInfo = new ProtocolLIBCONFIGInformation(parameters.getDevice(), playerList.toString().getBytes(), app, null);
					socket.sendMessage(app, protInfo);
				}
			});

			alert = builder.create();
			alert.show();
		}
		else {
			progressWaitGameStart = ProgressDialog.show(BatataQuenteActivity.this, "", "Esperando jogo comear", true, false);
		}
	}
	
	private void timerTaskUpdateTimePotato() {
		final Handler handler = new Handler();
		TimerTask timerTask = new TimerTask() {

			@Override
			public void run() {
				handler.post(new Runnable() {

					public void run() {
						if(potatoObject != null) {
							if(potatoWithMe && gameAlredyStart) {
								potatoObject.setAtualTime(potatoObject.getAtualTime() + 1);
								updatePotatoView();
								if(potatoObject.getPotatoState() == EPotatoState.QUEIMADA) {
									AlertDialog.Builder builder = new AlertDialog.Builder(BatataQuenteActivity.this);
									builder.setTitle("");
									builder.setMessage("Voc perdeu. Saia do jogo!");
									builder.setCancelable(false);
									builder.setPositiveButton("Sair", new OnClickListener() {
										
										public void onClick(DialogInterface arg0, int arg1) {
											finish();
										}
									});
									builder.create().show();
									timerUpdateTimePotato.cancel();
									AppProtocol app = new AppProtocol(EProtocolMessages.APPDATA, playerList.getIPList(parameters.getDevice().getIp()), EProtocolTranspLayer.TCP);
									ProtocolInformation infot = new ProtocolInformation(parameters.getDevice(), StatusCode.CODE_9, app);
									socket.sendMessage(app, infot);
								}
							}
							else
								potatoObject.setAtualTime(0);
						}
					}
				});
			}
		};
		
		timerUpdateTimePotato = new Timer();
		timerUpdateTimePotato.schedule(timerTask, 1000, 1000);
	}

	private void timerTaskUpdateViews() {
		final Handler handler = new Handler();
		TimerTask timerTask = new TimerTask() {

			@Override
			public void run() {
				handler.post(new Runnable() {

					public void run() {
						tvNickList.setText(strNickList);
						if(updatePotatoView) {
							updatePotatoView = false;
							updatePotatoView();
						}
						if(sendingPotatoError) {
							sendingPotatoError = false;
							Toast.makeText(BatataQuenteActivity.this, "Erro ao enviar a Batata", Toast.LENGTH_SHORT).show();
						}
					}
				});
			}
		};

		timerUpdateViews = new Timer();
		timerUpdateViews.schedule(timerTask, 1000, 1000);
	}

	private void iAmLeaving() {
		AppProtocol app = new AppProtocol(EProtocolMessages.APPDATA, playerList.getIPList(parameters.getDevice().getIp()), EProtocolTranspLayer.TCP);
		ProtocolInformation appInfo = new ProtocolInformation(parameters.getDevice(), StatusCode.CODE_8.getBytes(), app);
		socket.sendMessage(app, appInfo);
	}
	
	private void prepareSendPotato() {
		imageLargePotato.setOnClickListener(new View.OnClickListener() {

			public void onClick(View v) {
				if(potatoWithMe){
					if(soundPool.isLoaded())
						soundPool.play();
					AppProtocol app = new AppProtocol(EProtocolMessages.GEOMSG, ESendTo.ALL, EProtocolTranspLayer.UDP);
					ProtocolGEOMSGInformation info = new ProtocolGEOMSGInformation(parameters.getDevice(), StatusCode.CODE_4.getBytes(), app, null);
					socket.sendMessage(app, info);
					sendingPotato = true;
					potatoSended = false;
					waitSendPotato();
				}
				else {
					Toast.makeText(BatataQuenteActivity.this, "A batata no est com voce.", Toast.LENGTH_SHORT).show();
				}
			}
		});
	}
	
	private void waitSendPotato() {
		final ProgressDialog progress = ProgressDialog.show(BatataQuenteActivity.this, "", "Enviando a batata", true, false);
		
		new Thread() {
			public void run() {
				FutureTask<?> myTask;
				
				myTask = new FutureTask<Object>(new Runnable() {
					
					public void run() {
						while(sendingPotato){
							
						}
						if(!potatoSended) {
							sendingPotato = false;
							sendingPotatoError = true;
							//ERRO ao enviar batata
						}
						progress.dismiss();
					}
				}, null);
				
				new Thread(myTask).start();
				
				try {
					myTask.get(2L, TimeUnit.SECONDS);
				} catch (Exception e) {
					sendingPotato = false;
					sendingPotatoError = true;
					myTask.cancel(true);
					progress.dismiss();
					e.printStackTrace();
				}
			}
		}.start();
	}
	
	 public boolean onCreateOptionsMenu(Menu menu) {
	        menu.add(0, 0, 0, "Configuraes");
	        return super.onCreateOptionsMenu(menu);
	    }

	    public boolean onMenuItemSelected(int featureId, MenuItem item) {
	        Intent i = new Intent(BatataQuenteActivity.this, ConfigurationActivity.class);
	        startActivity(i);
	        return super.onMenuItemSelected(featureId, item);
	    }

}
