package android.usp.ime.tcc.newbatataquente;

import android.app.Activity;
import android.os.Bundle;
import android.usp.ime.tcc.geocommunication.Parameters;
import android.view.View;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.CompoundButton;
import android.widget.CompoundButton.OnCheckedChangeListener;
import android.widget.EditText;
import android.widget.TextView;

public class ConfigurationActivity extends Activity {

	private TextView tvNickName;
	private CheckBox cbSetLocation;
	private EditText setLatitude;
	private EditText setLongitude;
	private EditText setTargetRadius;
	private Button bOk;

	private Parameters parameters;

	@Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_configuration);
        
        parameters = Parameters.getInstance(null);
        
        tvNickName = (TextView) findViewById(R.id.playerName);
        cbSetLocation = (CheckBox) findViewById(R.id.checkBoxSetLocation);
        setLatitude = (EditText) findViewById(R.id.latitude);
        setLongitude = (EditText) findViewById(R.id.longitude);
        setTargetRadius = (EditText) findViewById(R.id.radius);
        bOk = (Button) findViewById(R.id.buttonOk);
        
        tvNickName.setText(parameters.getDevice().getNick());
        
        cbSetLocation.setOnCheckedChangeListener(new OnCheckedChangeListener() {
			
			public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
				if(isChecked) {
					parameters.getListenerLocation().disableLocationListener();
					setLatitude.setEnabled(true);
					setLongitude.setEnabled(true);
				}
				else {
					parameters.getListenerLocation().enableLocationService(getApplicationContext(), 0, 0);
					setLatitude.setEnabled(false);
					setLongitude.setEnabled(false);
				}
			}
		});
        
        bOk.setOnClickListener(new View.OnClickListener() {
			
			public void onClick(View v) {
				if(cbSetLocation.isChecked()) {
					if(setLatitude.getText() != null && !setLatitude.getText().toString().equals("") && setLongitude.getText() != null && !setLongitude.getText().toString().equals("")) {
						parameters.getDevice().getDeviceLocation().setLatitude(Double.parseDouble(setLatitude.getText().toString()));
						parameters.getDevice().getDeviceLocation().setLongitude(Double.parseDouble(setLongitude.getText().toString()));
					}
					parameters.getDevice().getDeviceLocation().setGpsEnable(true);
				}
				if(setTargetRadius.getText() != null && !setTargetRadius.getText().toString().equals(""))
					parameters.getTargetRestrictions().setRadius(Double.parseDouble(setTargetRadius.getText().toString()));
				finish();
			}
		});
    }
    
}
