package android.usp.ime.tcc.newbatataquente;

import java.util.Timer;
import java.util.TimerTask;

import usp.ime.gclib.Device;
import usp.ime.gclib.sensor.orientation.DeviceCompassOrientation;
import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.usp.ime.tcc.geocommunication.Parameters;
import android.usp.ime.tcc.soundVibrator.PlaySound;
import android.usp.ime.tcc.soundVibrator.Vibration;
import android.view.MotionEvent;
import android.view.View;
import android.view.View.OnTouchListener;
import android.widget.ImageView;

public class TelaDeApresentacaoActivity extends Activity{

	private int TIME_VIBRATOR = 700;
	
	private Timer t = new Timer();
	private TimerTask timerTask;
	private Handler handler = new Handler();
	
	private PlaySound soundPool;
	private Vibration vibrator;
	
	private ImageView batata1;
	private ImageView batata2;
	private ImageView batata3;
	private ImageView batata4;
	private View allView;
	
	private int verificaToque = 0;
	
	private Parameters parameters;
	private Device device;
	
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_tela_de_apresentacao);
        
        batata1 = (ImageView) findViewById(R.id.imageBatata1);
        batata2 = (ImageView) findViewById(R.id.imageBatata2);
        batata3 = (ImageView) findViewById(R.id.imageBatata3);
        batata4 = (ImageView) findViewById(R.id.imageBatata4);
        allView = (View) findViewById(R.id.allView);
        
        soundPool = new PlaySound(this);
        soundPool.initSound(R.raw.tique);
        vibrator = new Vibration(this);
        
        DeviceCompassOrientation compassOri = new DeviceCompassOrientation(); 
        device = new Device("", compassOri);
        
        parameters = Parameters.getInstance(device);
        
        parameters.getListenerLocation().enableLocationService(getApplicationContext(), 0, 0);
        parameters.getListenerOrientation().enableSensorService(getApplicationContext());
        
        criaTimerTask();
        
        allView.setOnTouchListener(new OnTouchListener() {
			
			public boolean onTouch(View arg0, MotionEvent event) {
				if(verificaToque == 0){
					verificaToque++;
					vibrator.vibra(TIME_VIBRATOR);
					if(soundPool.isLoaded()) 
						soundPool.play();
					
					Intent i = new Intent(TelaDeApresentacaoActivity.this, MenuPrincipalActivity.class);
					startActivity(i);
					t.cancel();
					finish();
					return true;
				}
				return false;
			}
		});
    }
    
    private void criaTimerTask() {
    	timerTask = new TimerTask() {
			@Override
			public void run() {
				handler.post(new Runnable() {
					public void run() {
						
						if(batata1.getVisibility() == View.VISIBLE) {
							batata1.setVisibility(View.INVISIBLE);
							batata2.setVisibility(View.VISIBLE);
						}
						else if(batata2.getVisibility() == View.VISIBLE) {
							batata2.setVisibility(View.INVISIBLE);
							batata3.setVisibility(View.VISIBLE);
						}
						else if(batata3.getVisibility() == View.VISIBLE) {
							batata3.setVisibility(View.INVISIBLE);
							batata4.setVisibility(View.VISIBLE);
						}
						else if(batata4.getVisibility() == View.VISIBLE) {
							batata4.setVisibility(View.INVISIBLE);
							batata1.setVisibility(View.VISIBLE);
						}
					}
				});
			}
		};
		
		t.schedule(timerTask, 0, 500);
    }
    
    @Override
    public void onBackPressed() {
    	super.onBackPressed();
    	System.exit(0);
    }

}
