package android.usp.ime.tcc.soundVibrator;

import android.content.Context;
import android.media.AudioManager;
import android.media.SoundPool;
import android.media.SoundPool.OnLoadCompleteListener;

public class PlaySound {

	private SoundPool soundPool;
	private int soundID;
	private boolean isLoaded = false;
	private Context context;
	
	public PlaySound(Context context) {
		this.context = context;
		soundPool = new SoundPool(1, AudioManager.STREAM_MUSIC, 0);
	}
	
	public void initSound(int id) {
        soundID = soundPool.load(context, id, 1);
        soundPool.setOnLoadCompleteListener(new OnLoadCompleteListener() {
			
			public void onLoadComplete(SoundPool arg0, int arg1, int arg2) {
				isLoaded = true;
			}
		});
	}
	
	public boolean isLoaded() {
		return isLoaded;
	}
	
	public void play() {
		if(isLoaded) {
			soundPool.play(soundID, 1, 1, 1, 0, 1f);
		}
	}
	
}
